source: master.sh@ 9e1915a

experimental
Last change on this file since 9e1915a was 386bc75, checked in by George Boudreau <georgeb@…>, 18 years ago

CLFS, trap vim-lang pack, install only on config flag

  • Property mode set to 100755
File size: 7.8 KB
Line 
1#!/bin/bash
2# $Id$
3set -e
4
5
6#>>>>>>>>>>>>>>>ERROR TRAPPING >>>>>>>>>>>>>>>>>>>>
7#-----------------------#
8simple_error() { # Basic error trap.... JUST DIE
9#-----------------------#
10 # If +e then disable text output
11 if [[ "$-" =~ "e" ]]; then
12 echo -e "\n${RED}ERROR:${GREEN} basic error trapped!${OFF}\n" >&2
13 fi
14}
15
16see_ya() {
17 echo -e "\n\t${BOLD}Goodbye and thank you for choosing ${L_arrow}JHALFS${R_arrow}\n"
18}
19##### Simple error TRAPS
20# ctrl-c SIGINT
21# ctrl-y
22# ctrl-z SIGTSTP
23# SIGHUP 1 HANGUP
24# SIGINT 2 INTRERRUPT FROM KEYBOARD Ctrl-C
25# SIGQUIT 3
26# SIGKILL 9 KILL
27# SIGTERM 15 TERMINATION
28# SIGSTOP 17,18,23 STOP THE PROCESS
29#####
30set -e
31trap see_ya 0
32trap simple_error ERR
33trap 'echo -e "\n\n${RED}INTERRUPT${OFF} trapped\n" && exit 2' 1 2 3 15 17 18 23
34#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
35
36
37if [ ! -L $0 ] ; then
38 echo "${nl_}${tab_}${BOLD}${RED}This script cannot be called directly: EXITING ${OFF}${nl_}"
39 exit 1
40fi
41
42 PROGNAME=$(basename $0)
43 VERSION="0.0.1"
44 COMMON_DIR="common"
45 PACKAGE_DIR=$(echo $PROGNAME | tr [a-z] [A-Z])
46 MODULE=$PACKAGE_DIR/master.sh
47MODULE_CONFIG=$PACKAGE_DIR/config
48
49echo -n "Loading common-functions module..."
50source $COMMON_DIR/common-functions
51[[ $? > 0 ]] && echo " $COMMON_DIR/common-functions did not load.." && exit
52echo "OK"
53#
54
55echo -n "Loading masterscript conf..."
56source $COMMON_DIR/config
57[[ $? > 0 ]] && echo "$COMMON_DIR/conf did not load.." && exit
58echo "OK"
59#
60echo -n "Loading config module <$MODULE_CONFIG>..."
61source $MODULE_CONFIG
62[[ $? > 0 ]] && echo "$MODULE_CONFIG did not load.." && exit 1
63echo "OK"
64#
65echo -n "Loading code module <$MODULE>..."
66source $MODULE
67[[ $? > 0 ]] && echo "$MODULE did not load.." && exit 2
68echo "OK"
69#
70echo "---------------${nl_}"
71
72
73#===========================================================
74# If the var BOOK contains something then, maybe, it points
75# to a working doc.. set WC=1, else 'null'
76#===========================================================
77WC=${BOOK:+1}
78#===========================================================
79
80
81#*******************************************************************#
82echo -n "Loading function <func_check_version.sh>..."
83source $COMMON_DIR/func_check_version.sh
84[[ $? > 0 ]] && echo " function module did not load.." && exit 2
85echo "OK"
86
87echo -n "Loading function <func_validate_configs.sh>..."
88source $COMMON_DIR/func_validate_configs.sh
89[[ $? > 0 ]] && echo " function module did not load.." && exit 2
90echo "OK"
91echo "---------------${nl_}"
92
93
94###################################
95### MAIN ###
96###################################
97
98# Evaluate any command line switches
99
100while test $# -gt 0 ; do
101 case $1 in
102 --version | -V )
103 clear
104 echo "$version"
105 exit 0
106 ;;
107
108 --help | -h )
109 if [[ "$PROGNAME" = "blfs" ]]; then
110 blfs_usage
111 else
112 usage
113 fi
114 ;;
115
116 --LFS-version | -L )
117 test $# = 1 && eval "$exit_missing_arg"
118 shift
119 case $1 in
120 dev* | SVN | trunk )
121 LFSVRS=development
122 ;;
123 6.1.1 )
124 echo "For stable 6.1.1 book, please use jhalfs-0.2."
125 exit 0
126 ;;
127 alpha*)
128 LFSVRS=alphabetical
129 ;;
130 * )
131 echo "$1 is an unsupported version at this time."
132 exit 1
133 ;;
134 esac
135 ;;
136
137 --directory | -d )
138 test $# = 1 && eval "$exit_missing_arg"
139 shift
140 BUILDDIR=$1
141 JHALFSDIR=$BUILDDIR/jhalfs
142 LOGDIR=$JHALFSDIR/logs
143 MKFILE=$JHALFSDIR/${PROGNAME}-Makefile
144 ;;
145
146 --rebuild ) CLEAN=1 ;;
147
148 --download-client | -D )
149 echo "The download feature is temporarily disable.."
150 exit
151 test $# = 1 && eval "$exit_missing_arg"
152 shift
153 DL=$1
154 ;;
155
156 --working-copy | -W )
157 test $# = 1 && eval "$exit_missing_arg"
158 shift
159 if [ -f $1/patches.ent ] ; then
160 WC=1
161 BOOK=$1
162 else
163 echo -e "\nLook like $1 isn't a supported working copy."
164 echo -e "Verify your selection and the command line.\n"
165 exit 1
166 fi
167 ;;
168
169 --testsuites | -T )
170 test $# = 1 && eval "$exit_missing_arg"
171 shift
172 case $1 in
173 0 | 1 | 2 | 3 )
174 TEST=$1
175 ;;
176 * )
177 echo -e "\n$1 isn't a valid testsuites level value."
178 echo -e "You must to use 0, 1, 2, or 3.\n"
179 exit 1
180 ;;
181 esac
182 ;;
183
184 --get-packages | -P ) HPKG=1 ;;
185 --run-make | -M ) RUNMAKE=1 ;;
186 --no-strip ) STRIP=0 ;;
187 --no-vim-lang ) VIMLANG=0 ;;
188
189 --page_size )
190 test $# = 1 && eval "$exit_missing_arg"
191 shift
192 case $1 in
193 letter | A4 )
194 PAGE=$1
195 ;;
196 * )
197 echo "$1 isn't a supported page size."
198 exit 1
199 ;;
200 esac
201 ;;
202
203 --timezone )
204 test $# = 1 && eval "$exit_missing_arg"
205 shift
206 if [ -f /usr/share/zoneinfo/$1 ] ; then
207 TIMEZONE=$1
208 else
209 echo -e "\nLooks like $1 isn't a valid timezone description."
210 echo -e "Verify your selection and the command line.\n"
211 exit 1
212 fi
213 ;;
214
215 --fstab )
216 test $# = 1 && eval "$exit_missing_arg"
217 shift
218 if [ -f $1 ] ; then
219 FSTAB=$1
220 else
221 echo -e "\nFile $1 not found. Verify your command line.\n"
222 exit 1
223 fi
224 ;;
225
226 --kernel-config | -C )
227 test $# = 1 && eval "$exit_missing_arg"
228 shift
229 if [ -f $1 ] ; then
230 CONFIG=$1
231 else
232 echo -e "\nFile $1 not found. Verify your command line.\n"
233 exit 1
234 fi
235 ;;
236
237 * )
238 if [[ "$PROGNAME" = "blfs" ]]; then
239 blfs_usage
240 else
241 usage
242 fi
243 ;;
244 esac
245 shift
246done
247
248# Find the download client to use, if not already specified.
249
250if [ -z $DL ] ; then
251 if [ `type -p wget` ] ; then
252 DL=wget
253 elif [ `type -p curl` ] ; then
254 DL=curl
255 else
256 eval "$no_dl_client"
257 fi
258fi
259
260#===================================================
261# Set the document location...
262# BOOK is either defined in
263# xxx.config
264# comand line
265# default
266# If set by conf file leave or cmd line leave it
267# alone otherwise load the default version
268#===================================================
269BOOK=${BOOK:=$PROGNAME-$LFSVRS}
270#===================================================
271
272
273# Check for minumum gcc and kernel versions
274#check_requirements 1 # 0/1 0-do not display values.
275check_version "2.6.2" "`uname -r`" "KERNEL"
276check_version "3.0" "$BASH_VERSION" "BASH"
277check_version "3.0" "`gcc -dumpversion`" "GCC"
278tarVer=`tar --version`
279check_version "1.15.0" "${tarVer##* }" "TAR"
280echo "---------------${nl_}"
281
282validate_config 1 # 0/1 0-do not display values
283echo "---------------${nl_}"
284
285echo -n "Are you happy with that settings? yes/no (no): "
286read ANSWER
287if [ x$ANSWER != "xyes" ] ; then
288 echo "${nl_}Fix the configuration options and rerun the script.${nl_}"
289 exit 1
290fi
291
292# Prevents setting "-d /" by mistake.
293
294if [ $BUILDDIR = / ] ; then
295 echo -ne "\nThe root directory can't be used to build LFS.\n\n"
296 exit 1
297fi
298
299# If $BUILDDIR has subdirectories like tools/ or bin/, stop the run
300# and notify the user about that.
301
302if [ -d $BUILDDIR/tools -o -d $BUILDDIR/bin ] && [ -z $CLEAN ] ; then
303 eval "$no_empty_builddir"
304fi
305
306# If requested, clean the build directory
307clean_builddir
308
309if [[ ! -d $JHALFSDIR ]]; then
310 mkdir -pv $JHALFSDIR
311fi
312
313if [[ "$PWD" != "$JHALFSDIR" ]]; then
314 cp -v $COMMON_DIR/makefile-functions $JHALFSDIR/
315 if [[ -n "$FILES" ]]; then
316 # pushd/popd necessary to deal with mulitiple files
317 pushd $PACKAGE_DIR
318 cp -v $FILES $JHALFSDIR/
319 popd
320 fi
321 sed 's,FAKEDIR,'$BOOK',' $PACKAGE_DIR/$XSL > $JHALFSDIR/${XSL}
322 export XSL=$JHALFSDIR/${XSL}
323fi
324
325if [[ ! -d $LOGDIR ]]; then
326 mkdir -v $LOGDIR
327fi
328>$LOGDIR/$LOG
329echo "---------------${nl_}"
330
331get_book
332echo "---------------${nl_}"
333
334build_Makefile
335echo "---------------${nl_}"
336
337run_make
338
Note: See TracBrowser for help on using the repository browser.